'
' BASIC.bas
'
' Demo/prototype of a "quick & easy" BASIC IDE based upon the VT2000
' standard
'
' It would be an editor just working with text "graphics", if you hit
' "Run" (F10), the project will be saved, compiled and executed. The
' "Direct" Mode is ment for direct execution of single BASIC instructions,
' therefore testing. The output canvas of "Run" might be manipulated too.
'

#INCLUDE "retrogra.bi"

FUNCTION N(text AS STRING) AS STRING
  RETURN PRINTCOLOR(240,215)+text
END FUNCTION
FUNCTION K(text AS STRING) AS STRING
  RETURN PRINTCOLOR(3,215)+text
END FUNCTION
FUNCTION F(text AS STRING) AS STRING
  RETURN PRINTCOLOR(15,215)+text
END FUNCTION
FUNCTION S(text AS STRING) AS STRING
  RETURN PRINTCOLOR(54,215)+text
END FUNCTION
FUNCTION T(text AS STRING) AS STRING
  RETURN PRINTCOLOR(180,215)+text
END FUNCTION
FUNCTION C(text AS STRING) AS STRING
  RETURN PRINTCOLOR(198,215)+text
END FUNCTION
FUNCTION V(text AS STRING) AS STRING
  RETURN PRINTCOLOR(86,215)+text
END FUNCTION

DECLARE SUB REDRAW
DECLARE SUB ADDINFOS

DIM AS INTEGER i, m, mx, my, mb
DIM AS BOOLEAN overwritemode
DIM AS STRING key, dstr
DIM shared AS STRING*16 menu(20)={"Load","Merge","New","Quit","Menu","Release","Help","Hide|Show","Direct","Run","Save","Export","Close","Clo.All","Disable|Enable","Debug","Config","Insert|Overwr.","Flip",_
"Test"}
DIM AS DIALOGFLAG mbb

rgSCREENNEW
LOCALESETLANGUAGE("en") ' sets language to English => English-only application

REDRAW
MESSAGEBOX "This is an "+CHR(34)+"interactive"+CHR(34)+" demonstration of a possible BASIC editor (and perhaps interpreter) based upon the VT2000 console. The menu could be used with the function keys.", ALERT, mbb

m=0
rgPRINT PRINTCOLOR(240,215)
DO
  rgGETMOUSE mx, my, , mb
  key=rgINKEY()
  IF mb=1 THEN ' mouse click
    IF my<32 THEN ' inside menu
      m=((mx-4) SHR 6) ' each entry is 64 bits broad, border is in the middle of the pipes
      IF m<0 THEN m=0
      IF my>15 THEN
        m+=10
      ENDIF
      m+=1 ' <>0 means menu entry selected
    ELSEIF my<48 THEN ' tab line
      MESSAGEBOX "At the left and the right side you may scroll to additional file tabs. The tab symbols are showing, whether their file has been changed resp. saved. Only the currently active tab could be closed.", mbb
    ELSE
      MESSAGEBOX "The editor performs automatic instant indention, autocompletion and code-highlighting, but also syntax-checking.", INFO, " _More|0_Abort", mbb
      IF mbb=1 THEN MESSAGEBOX "If you enter e.g. an IF-line, it already indents while typing, appends a THEN and tries to add a matching ENDIF line.", INFO, " _More|0_Abort", mbb
      IF mbb=1 THEN MESSAGEBOX "The autoindention only applies inside the current SUB or FUNCTION. The code won't run with wrong ENDIFs and so on of course.", INFO, " _More|0_Abort", mbb
      IF mbb=1 THEN MESSAGEBOX "After hitting Enter resp. when leaving the line, the syntax gets checked, including unknown/mistyped symbol names. You can only proceed with an accepted syntax, at a pinch, making the line a comment.", INFO, " _More|0_Abort", mbb
      IF mbb=1 THEN MESSAGEBOX "The whole source code scrolls horizontally with wide steps when reaching the screen border.", INFO, " _More|0_Abort", mbb
      IF mbb=1 THEN MESSAGEBOX "Marking for copy & paste only works letter-wise inside a line, or with multiple complete lines. When pasting, autoindention and syntax checks are performed.", INFO, mbb
    ENDIF
  ELSEIF mb=2 THEN ' right click (context menu)
    ADDINFOS
    MESSAGEBOX "The editor does also have contextual menus, but will additionally superimpose line numbers, scrollbar and other infos for a short time when pressing the right mouse button.", INFO, mbb
    MESSAGEBOX "You can access e.g. the scrollbar until it vanishes. It is also shown while scrolling with Page Up/Down, but won't never disturb or being accidently operated.", INFO, mbb
    REDRAW
  ENDIF

  IF key>"" THEN
    i=ASC(key)
    IF i>239 AND i<250 THEN ' function key F1-F10
      ' highlight menu entry
      i-=240
      IF rgSHIFTKEYS(255)=SHIFT THEN i+=10
      m=i+1
    ELSE
      ' other keys
      IF i=25 THEN ' Insert
        MESSAGEBOX "The Insert key inserts a new line.",INFO,mbb
      ENDIF
      IF rgSHIFTKEYS(255)=CMD AND (i=102 OR i=103 OR i=104) THEN ' Ctrl+F/G/H
        MESSAGEBOX "Text searching and replacing is of course also possible.",mbb
      ENDIF
    ENDIF
  ENDIF
  IF m THEN
    m-=1
    dstr=menu(m)
    i=INSTR(dstr, "|")
    IF i THEN
      dstr=LEFT(dstr, i-1)
    ENDIF
    i=LEN(dstr)
    IF i<6 THEN
      dstr=SPACE((7-i) SHR 1)+dstr+SPACE((8-i) SHR 1)
    ELSEIF i=6 THEN
      dstr+=" "
    ENDIF
    IF m<>7 AND m<>14 AND m<>17 THEN ' don't highlight these menu items
      IF m=9 OR m=19 THEN dstr=LEFT(dstr,6)
      IF m>9 THEN
        i=((m-10) SHL 3)+2
        rgPRINT AT(i,2)+dstr
      ELSE
        i=(m SHL 3)+2
        rgPRINT AT(i,1)+dstr
      ENDIF
    ENDIF
    rgSCREENSHOW

    ' execute menu entry
    SELECT CASE m
      CASE 0
        MESSAGEBOX "This opens a BASIC or text file. If using some sort of BASIC bytecode it will load such files too.","Information: Load",INFO,mbb
      CASE 1
        MESSAGEBOX "Merges a text file into the current file before the current line. Doesn't matter whether BASIC or another text file, except for BASIC files the syntax will be validated.","Information: Merge",INFO,mbb
      CASE 2
        MESSAGEBOX "Creates a new file you may give a name to demand the file type. When saving, you'll be asked where to put it to, resp. to give it a name. ("+CHR(34)+"untitled"+CHR(34)+" would be a bad choice)","Information: New",INFO,mbb
      CASE 3
        MESSAGEBOX "Do you want to leave the demo ?","Exit Program",CAST(DIALOGFLAG,DIALOGFLAG.QUESTION+YESNO),mbb
        IF mbb=YES THEN
          EXIT DO
        ENDIF
      CASE 4
        MESSAGEBOX "There is a much more comprehensive menu with special functions like symbol editor, macro editor etc. hidden behind this menu item.","Information: Menu",INFO,mbb
      CASE 5
        MESSAGEBOX "The BASIC IDE can perform (BASIC) scripted generation of project builds. This one is for compiling and bundling a release build, e.g. into a ZIP file, maybe branching into a full and demo version etc.","Information: Release",INFO,mbb
      CASE 6
        MESSAGEBOX "This is the entrace to the integrated hypertext help, user manual and instruction reference. Can also include library documentations and browse the comments of included BASIC files.","Information: Help",INFO,mbb
      CASE 7
        MESSAGEBOX "You can collapse SUBs and FUNCTIONs to one line, but also statements like IF until its belonging ELSE resp. ENDIF. The IDE tries to store the positions. Also collapses SUBs and FUNCTIONS automatically when loading if they are very long.","Information: Hide/Show",INFO,mbb
        MESSAGEBOX "You can also mark a random part and hide it, where the indention and helping lines will stay correct. The editor will insert the (invisible) comments "+CHR(34)+"' #HIDE!"+CHR(34)+" and "+CHR(34)+"' #ENDHIDE!"+CHR(34)+", so this collapsing is safely stored.","Information: Hide/Show",INFO,mbb
        MESSAGEBOX "The menu item automatically switches between "+CHR(34)+"Hide"+CHR(34)+" and "+CHR(34)+"Show"+CHR(34)+", depending on whether the cursor is in a collapsed line. Collapsing only works with instructions in a line like SUB or with several selected lines.",INFO,mbb
      CASE 8
        MESSAGEBOX "The direct mode is a kind of console where you can execute(test) BASIC instructions directly. It uses the output canvas.","Information: Direct",INFO,mbb
      CASE 9
        MESSAGEBOX "Run saves all project files, checks and starts the BASIC program. Compiles it if not interpreted. Smartly determines which (source) file is to execute, even if not currently selected.","Information: Run",INFO,mbb
      CASE 10
        MESSAGEBOX "This saves all changed opened files, independend of their file format.","Information: Save",CAST(DIALOGFLAG,INFO+SAVEALLCANCEL),mbb
      CASE 11
        MESSAGEBOX "Exports the selected text as/into a text file.","Information: Export",INFO,mbb
      CASE 12
        MESSAGEBOX "Closes the currently selected/edited file. You may also use the closer on the tab of course.","Information: Close",CAST(DIALOGFLAG,INFO+SAVECANCEL),mbb
      CASE 13
        MESSAGEBOX "You broke the Internet !","Information: Clo(se) All",DIALOGFLAG.ERROR," _Forddammit!",mbb
      CASE 14
        MESSAGEBOX "This out-comments or un-comments the currently selected code or current line. It places a ' before all lines, so they won't get compiled/interpreted. Smartly distinguishes valid code from comments.","Information: Disable/Enable",INFO,mbb
      CASE 15
        MESSAGEBOX "The BASIC IDE can perform (BASIC) scripted generation of project builds. This one might compile and link with debug informations and run a debugger.","Information: Debug",INFO,mbb
      CASE 16
        MESSAGEBOX "Opens the config settings dialog. Among other things code highlighting options and symbol representation.","Information: Config",INFO,mbb
      CASE 17
        IF overwritemode THEN
          overwritemode=FALSE
          rgPRINT AT(58,2)+ESC("A")+"Insert "+ESC("a")
        ELSE
          overwritemode=TRUE
          rgPRINT AT(58,2)+ESC("A")+"Overwr."+ESC("a")
        ENDIF
        MESSAGEBOX "Switches between insert and overwrite editing mode. The Insert key inserts a new line though.","Information: Insert/Overwrite",INFO,mbb
      CASE 18
        MESSAGEBOX "Switches to the output canvas, where the program or direct mode are putting out.","Information: Flip",INFO,mbb
      CASE 19
        MESSAGEBOX "Performs a full syntax test of all project files like Run, but just doesn't start the executable.","Information: Test",INFO,mbb
    END SELECT
    FOR i=1 TO 10
      SLEEP 10
      rgSCREENSHOW
    NEXT

    IF m>9 THEN
      i=((m-10) SHL 3)+2
      rgPRINT AT(i,2)+ESC("A")+dstr+ESC("a")
    ELSE
      i=(m SHL 3)+2
      rgPRINT AT(i,1)+ESC("A")+dstr+ESC("a")
    ENDIF
    IF overwritemode THEN
      rgPRINT AT(58,2)+ESC("A")+"Overwr."+ESC("a")
    ELSE
      rgPRINT AT(58,2)+ESC("A")+"Insert "+ESC("a")
    ENDIF
    m=0
  ENDIF
  SLEEP 10
  rgSCREENSHOW
LOOP

SLEEP 250
rgSCREENDELETE
END

SUB ADDINFOS
  DIM AS INTEGER i, mx, my

  rgGETMOUSE(mx, my, , )
  rgPRINT PRINTCOLOR(240,86)
  FOR i=4 TO 30
    rgPRINT AT(80,i)+" "
  NEXT
  rgPRINT PRINTCOLOR(240,172)
  FOR i=4 TO 29
    rgPRINT AT(1,i)+" "+STR(i+1145)
  NEXT
  rgPRINT AT(1,4)+" 1088"
  rgPRINT AT(80,11)+" "
  rgPRINT PRINTCOLOR(240,215)
  rgPRINT AT(80,4)+CHR(26,33)
  rgPRINT AT(80,30)+CHR(26,34)
  rgPRINT AT(1,30)+ESC("A")+SPACE(79)
  rgPRINT AT(1,30)+"Line "+STR((my SHR 4)+1085)+"/2573  Pos. "+STR(mx SHR 3)
  rgPRINT AT(36,30)+TIME
  rgPRINT ESC("a")
  rgSCREENSHOW
END SUB

SUB REDRAW
  DIM AS INTEGER i, m
  DIM AS STRING dstr

  rgCLS
  rgPRINT ESC("A")
  FOR m=0 TO 19
    dstr=menu(m)
    i=INSTR(dstr, "|")
    IF i THEN
      dstr=LEFT(dstr, i-1)
    ENDIF
    i=LEN(dstr)
    IF i<6 THEN
      dstr=SPACE((7-i) SHR 1)+dstr+SPACE((8-i) SHR 1)
    ELSEIF i=6 THEN
      dstr+=" "
    ENDIF
    rgPRINT "|"+dstr
    IF m=9 OR m=19 THEN rgPRINT CHR(3)+"|" ' 1 left
  NEXT

  ' file tabs
  rgPRINT AT(1,3)+SPACE(80)+ESC("a") ' black row, end menu block

  rgPRINT AT(1,3)+PRINTCOLOR(86,240)+CHR(26,35)
  rgPRINT PRINTCOLOR(43,86)
  rgPRINT CHR(27,65,26,56,27,97)+"main.bas  "+CHR(27,65,26,57,27,97)
  rgPRINT CHR(27,65,26,56,27,97)+"extend.bi  "+CHR(27,65,26,57,27,97)
  rgPRINT PRINTCOLOR(240,215)
  rgPRINT CHR(27,65,26,56,27,97)+"retrogra.bi  "+CHR(27,65,26,57,27,97)
  rgPRINT PRINTCOLOR(43,86)
  rgPRINT CHR(27,65,26,56,27,97)+"utf8.bi  "+CHR(27,65,26,57,27,97)
  rgPRINT AT(12,3)+PRINTCOLOR(21,86)+UTF8(&h2692) ' "in work"
  rgPRINT AT(25,3)+PRINTCOLOR(12,86)+CHR(26,41)+AT(51,3)+CHR(26,41) ' checkmarks
  rgPRINT AT(40,3)+PRINTCOLOR(4,215)+UTF8(&h2720) ' closer
  rgPRINT PRINTCOLOR(240,215)

  ' source code area
  rgPRINT AT(1,4)+PRINTCOLOR(5,2)+CHR(26,33)+K("SUB ")+F("rgcSETPIXEL")+N("(")+k("BYVAL ")+S("vout ")+K("AS ")+T("BYTE PTR")+N(", ")+T("BYVAL ")+S("colour ")+K("AS ")+T("UBYTE)")

  rgPRINT AT(1,5)+K("SUB ")+F("rgcREFRESH")

  rgPRINT AT(3,6)+C("' puts out the whole console content, based on its char buffer")

  rgPRINT AT(3,7)+K("DIM AS ")+T("UBYTE PTR ")+S("vout")+N(", ")+S("cdp")

  rgPRINT AT(3,8)+K("DIM AS ")+T("INTEGER ")+S("x")+N(", ")+S("y")+N(", ")+S("lo")+N("=")+V("0")+N(", ")+S("ls")+N(", ")+S("i")+N(", ")+S("j")
  '
  rgPRINT AT(3,10)+S("vout")+N("=")+F("SCREENPT")+PRINTCOLOR(130,240)+"R"

  rgPRINT AT(3,11)+S("lo")+N("=")+S("retrogra_cwidth")

  rgPRINT AT(3,12)+S("lo")+N("-=")+V("8 ")+C("' offset to next line (after printing 8 pixels)")

  rgPRINT AT(3,14)+K("FOR ")+S("y")+N("=")+V("0 ")+K("TO ")+V("29")

  rgPRINT AT(3,15)+PRINTCOLOR(173,215)+UTF8(9482,32)
  rgPRINT K("FOR ")+S("y")+N("=")+V("0 ")+K("TO ")+V("79")

  rgPRINT AT(3,16)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)
  rgPRINT K("IF ")+S("rgccell")+N("(")+S("x")+N(",")+S("y")+N(").")+S("flags ")+K("THEN ")+C("' character to print")

  rgPRINT AT(3,17)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT S("i")+N("=")+V("16")

  rgPRINT AT(3,18)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT K("WHILE ")+S("i")

  rgPRINT AT(3,19)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT S("i")+N("-=")+V("1")

  rgPRINT AT(3,20)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT S("cfl")+N("=")+F("PEEK")+N("(")+T("UBYTE")+N(", ")+S("cdp")+N(")")

  rgPRINT AT(3,21)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT S("j")+N("=")+V("8")

  rgPRINT AT(3,22)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)
  rgPRINT K("WHILE ")+S("j")

  rgPRINT AT(3,23)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT S("j")+N("-=")+V("1")

  rgPRINT AT(3,24)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT K("IF ")+N("(")+S("cfl ")+K("AND ")+V("1")+N(") ")+K("THEN ")+C("' foreground pixel")

  rgPRINT AT(3,25)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  rgPRINT K("IF ")+S("fgcolour")+N("<")+V("240 ")+K("THEN")

  rgPRINT AT(3,26)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)+PRINTCOLOR(173,215)+UTF8(9482,32)
  rgPRINT N("*")+S("vout")+N("=")+S("fgcolour")

  rgPRINT AT(3,27)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  rgPRINT K("ELSE")

  rgPRINT AT(3,28)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)
  rgPRINT PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)+PRINTCOLOR(173,215)+UTF8(9482,32)
  rgPRINT F("rgcSETPIXEL")+N("(")+S("vout")+N(", ")+S("fgcolour")+N(")")

  rgPRINT AT(3,29)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)+PRINTCOLOR(209,215)+UTF8(9482,32)
  rgPRINT K("ENDIF")

  rgPRINT AT(3,30)+PRINTCOLOR(173,215)+UTF8(9482,32)+PRINTCOLOR(29,215)+UTF8(9482,32)+PRINTCOLOR(178,215)+UTF8(9482,32)+PRINTCOLOR(214,215)+UTF8(9482,32)+PRINTCOLOR(208,215)+UTF8(9482,32)
  rgPRINT K("ELSE ")+C("' background pixel")

  rgPRINT PRINTCOLOR(240,215)
  rgSCREENSHOW
END SUB

